let CSSNamedColors = {
    black: new Color("rgb", [(0 / 255), (0 / 255), (0 / 255), 1.0]),
    silver: new Color("rgb", [(192 / 255), (192 / 255), (192 / 255), 1.0]),
    gray: new Color("rgb", [(128 / 255), (128 / 255), (128 / 255), 1.0]),
    white: new Color("rgb", [(255 / 255), (255 / 255), (255 / 255), 1.0]),
    maroon: new Color("rgb", [(128 / 255), (0 / 255), (0 / 255), 1.0]),
    red: new Color("rgb", [(255 / 255), (0 / 255), (0 / 255), 1.0]),
    purple: new Color("rgb", [(128 / 255), (0 / 255), (128 / 255), 1.0]),
    fuchsia: new Color("rgb", [(255 / 255), (0 / 255), (255 / 255), 1.0]),
    green: new Color("rgb", [(0 / 255), (128 / 255), (0 / 255), 1.0]),
    lime: new Color("rgb", [(0 / 255), (255 / 255), (0 / 255), 1.0]),
    olive: new Color("rgb", [(128 / 255), (128 / 255), (0 / 255), 1.0]),
    yellow: new Color("rgb", [(255 / 255), (255 / 255), (0 / 255), 1.0]),
    navy: new Color("rgb", [(0 / 255), (0 / 255), (128 / 255), 1.0]),
    blue: new Color("rgb", [(0 / 255), (0 / 255), (255 / 255), 1.0]),
    teal: new Color("rgb", [(0 / 255), (128 / 255), (128 / 255), 1.0]),
    aqua: new Color("rgb", [(0 / 255), (255 / 255), (255 / 255), 1.0]),
    orange: new Color("rgb", [(255 / 255), (165 / 255), (0 / 255), 1.0]),
    aliceblue: new Color("rgb", [(240 / 255), (248 / 255), (255 / 255), 1.0]),
    antiquewhite: new Color("rgb", [(250 / 255), (235 / 255), (215 / 255), 1.0]),
    aquamarine: new Color("rgb", [(127 / 255), (255 / 255), (212 / 255), 1.0]),
    azure: new Color("rgb", [(240 / 255), (255 / 255), (255 / 255), 1.0]),
    beige: new Color("rgb", [(245 / 255), (245 / 255), (220 / 255), 1.0]),
    bisque: new Color("rgb", [(255 / 255), (228 / 255), (196 / 255), 1.0]),
    blanchedalmond: new Color("rgb", [(255 / 255), (235 / 255), (205 / 255), 1.0]),
    blueviolet: new Color("rgb", [(138 / 255), (43 / 255), (226 / 255), 1.0]),
    brown: new Color("rgb", [(165 / 255), (42 / 255), (42 / 255), 1.0]),
    burlywood: new Color("rgb", [(222 / 255), (184 / 255), (135 / 255), 1.0]),
    cadetblue: new Color("rgb", [(95 / 255), (158 / 255), (160 / 255), 1.0]),
    chartreuse: new Color("rgb", [(127 / 255), (255 / 255), (0 / 255), 1.0]),
    chocolate: new Color("rgb", [(210 / 255), (105 / 255), (30 / 255), 1.0]),
    coral: new Color("rgb", [(255 / 255), (127 / 255), (80 / 255), 1.0]),
    cornflowerblue: new Color("rgb", [(100 / 255), (149 / 255), (237 / 255), 1.0]),
    cornsilk: new Color("rgb", [(255 / 255), (248 / 255), (220 / 255), 1.0]),
    crimson: new Color("rgb", [(220 / 255), (20 / 255), (60 / 255), 1.0]),
    darkblue: new Color("rgb", [(0 / 255), (0 / 255), (139 / 255), 1.0]),
    darkcyan: new Color("rgb", [(0 / 255), (139 / 255), (139 / 255), 1.0]),
    darkgoldenrod: new Color("rgb", [(184 / 255), (134 / 255), (11 / 255), 1.0]),
    darkgray: new Color("rgb", [(169 / 255), (169 / 255), (169 / 255), 1.0]),
    darkgreen: new Color("rgb", [(0 / 255), (100 / 255), (0 / 255), 1.0]),
    darkgrey: new Color("rgb", [(169 / 255), (169 / 255), (169 / 255), 1.0]),
    darkkhaki: new Color("rgb", [(189 / 255), (183 / 255), (107 / 255), 1.0]),
    darkmagenta: new Color("rgb", [(139 / 255), (0 / 255), (139 / 255), 1.0]),
    darkolivegreen: new Color("rgb", [(85 / 255), (107 / 255), (47 / 255), 1.0]),
    darkorange: new Color("rgb", [(255 / 255), (140 / 255), (0 / 255), 1.0]),
    darkorchid: new Color("rgb", [(153 / 255), (50 / 255), (204 / 255), 1.0]),
    darkred: new Color("rgb", [(139 / 255), (0 / 255), (0 / 255), 1.0]),
    darksalmon: new Color("rgb", [(233 / 255), (150 / 255), (122 / 255), 1.0]),
    darkseagreen: new Color("rgb", [(143 / 255), (188 / 255), (143 / 255), 1.0]),
    darkslateblue: new Color("rgb", [(72 / 255), (61 / 255), (139 / 255), 1.0]),
    darkslategray: new Color("rgb", [(47 / 255), (79 / 255), (79 / 255), 1.0]),
    darkslategrey: new Color("rgb", [(47 / 255), (79 / 255), (79 / 255), 1.0]),
    darkturquoise: new Color("rgb", [(0 / 255), (206 / 255), (209 / 255), 1.0]),
    darkviolet: new Color("rgb", [(148 / 255), (0 / 255), (211 / 255), 1.0]),
    deeppink: new Color("rgb", [(255 / 255), (20 / 255), (147 / 255), 1.0]),
    deepskyblue: new Color("rgb", [(0 / 255), (191 / 255), (255 / 255), 1.0]),
    dimgray: new Color("rgb", [(105 / 255), (105 / 255), (105 / 255), 1.0]),
    dimgrey: new Color("rgb", [(105 / 255), (105 / 255), (105 / 255), 1.0]),
    dodgerblue: new Color("rgb", [(30 / 255), (144 / 255), (255 / 255), 1.0]),
    firebrick: new Color("rgb", [(178 / 255), (34 / 255), (34 / 255), 1.0]),
    floralwhite: new Color("rgb", [(255 / 255), (250 / 255), (240 / 255), 1.0]),
    forestgreen: new Color("rgb", [(34 / 255), (139 / 255), (34 / 255), 1.0]),
    gainsboro: new Color("rgb", [(220 / 255), (220 / 255), (220 / 255), 1.0]),
    ghostwhite: new Color("rgb", [(248 / 255), (248 / 255), (255 / 255), 1.0]),
    gold: new Color("rgb", [(255 / 255), (215 / 255), (0 / 255), 1.0]),
    goldenrod: new Color("rgb", [(218 / 255), (165 / 255), (32 / 255), 1.0]),
    greenyellow: new Color("rgb", [(173 / 255), (255 / 255), (47 / 255), 1.0]),
    grey: new Color("rgb", [(128 / 255), (128 / 255), (128 / 255), 1.0]),
    honeydew: new Color("rgb", [(240 / 255), (255 / 255), (240 / 255), 1.0]),
    hotpink: new Color("rgb", [(255 / 255), (105 / 255), (180 / 255), 1.0]),
    indianred: new Color("rgb", [(205 / 255), (92 / 255), (92 / 255), 1.0]),
    indigo: new Color("rgb", [(75 / 255), (0 / 255), (130 / 255), 1.0]),
    ivory: new Color("rgb", [(255 / 255), (255 / 255), (240 / 255), 1.0]),
    khaki: new Color("rgb", [(240 / 255), (230 / 255), (140 / 255), 1.0]),
    lavender: new Color("rgb", [(230 / 255), (230 / 255), (250 / 255), 1.0]),
    lavenderblush: new Color("rgb", [(255 / 255), (240 / 255), (245 / 255), 1.0]),
    lawngreen: new Color("rgb", [(124 / 255), (252 / 255), (0 / 255), 1.0]),
    lemonchiffon: new Color("rgb", [(255 / 255), (250 / 255), (205 / 255), 1.0]),
    lightblue: new Color("rgb", [(173 / 255), (216 / 255), (230 / 255), 1.0]),
    lightcoral: new Color("rgb", [(240 / 255), (128 / 255), (128 / 255), 1.0]),
    lightcyan: new Color("rgb", [(224 / 255), (255 / 255), (255 / 255), 1.0]),
    lightgoldenrodyellow: new Color("rgb", [(250 / 255), (250 / 255), (210 / 255), 1.0]),
    lightgray: new Color("rgb", [(211 / 255), (211 / 255), (211 / 255), 1.0]),
    lightgreen: new Color("rgb", [(144 / 255), (238 / 255), (144 / 255), 1.0]),
    lightgrey: new Color("rgb", [(211 / 255), (211 / 255), (211 / 255), 1.0]),
    lightpink: new Color("rgb", [(255 / 255), (182 / 255), (193 / 255), 1.0]),
    lightsalmon: new Color("rgb", [(255 / 255), (160 / 255), (122 / 255), 1.0]),
    lightseagreen: new Color("rgb", [(32 / 255), (178 / 255), (170 / 255), 1.0]),
    lightskyblue: new Color("rgb", [(135 / 255), (206 / 255), (250 / 255), 1.0]),
    lightslategray: new Color("rgb", [(119 / 255), (136 / 255), (153 / 255), 1.0]),
    lightslategrey: new Color("rgb", [(119 / 255), (136 / 255), (153 / 255), 1.0]),
    lightsteelblue: new Color("rgb", [(176 / 255), (196 / 255), (222 / 255), 1.0]),
    lightyellow: new Color("rgb", [(255 / 255), (255 / 255), (224 / 255), 1.0]),
    limegreen: new Color("rgb", [(50 / 255), (205 / 255), (50 / 255), 1.0]),
    linen: new Color("rgb", [(250 / 255), (240 / 255), (230 / 255), 1.0]),
    mediumaquamarine: new Color("rgb", [(102 / 255), (205 / 255), (170 / 255), 1.0]),
    mediumblue: new Color("rgb", [(0 / 255), (0 / 255), (205 / 255), 1.0]),
    mediumorchid: new Color("rgb", [(186 / 255), (85 / 255), (211 / 255), 1.0]),
    mediumpurple: new Color("rgb", [(147 / 255), (112 / 255), (219 / 255), 1.0]),
    mediumseagreen: new Color("rgb", [(60 / 255), (179 / 255), (113 / 255), 1.0]),
    mediumslateblue: new Color("rgb", [(123 / 255), (104 / 255), (238 / 255), 1.0]),
    mediumspringgreen: new Color("rgb", [(0 / 255), (250 / 255), (154 / 255), 1.0]),
    mediumturquoise: new Color("rgb", [(72 / 255), (209 / 255), (204 / 255), 1.0]),
    mediumvioletred: new Color("rgb", [(199 / 255), (21 / 255), (133 / 255), 1.0]),
    midnightblue: new Color("rgb", [(25 / 255), (25 / 255), (112 / 255), 1.0]),
    mintcream: new Color("rgb", [(245 / 255), (255 / 255), (250 / 255), 1.0]),
    mistyrose: new Color("rgb", [(255 / 255), (228 / 255), (225 / 255), 1.0]),
    moccasin: new Color("rgb", [(255 / 255), (228 / 255), (181 / 255), 1.0]),
    navajowhite: new Color("rgb", [(255 / 255), (222 / 255), (173 / 255), 1.0]),
    oldlace: new Color("rgb", [(253 / 255), (245 / 255), (230 / 255), 1.0]),
    olivedrab: new Color("rgb", [(107 / 255), (142 / 255), (35 / 255), 1.0]),
    orangered: new Color("rgb", [(255 / 255), (69 / 255), (0 / 255), 1.0]),
    orchid: new Color("rgb", [(218 / 255), (112 / 255), (214 / 255), 1.0]),
    palegoldenrod: new Color("rgb", [(238 / 255), (232 / 255), (170 / 255), 1.0]),
    palegreen: new Color("rgb", [(152 / 255), (251 / 255), (152 / 255), 1.0]),
    paleturquoise: new Color("rgb", [(175 / 255), (238 / 255), (238 / 255), 1.0]),
    palevioletred: new Color("rgb", [(219 / 255), (112 / 255), (147 / 255), 1.0]),
    papayawhip: new Color("rgb", [(255 / 255), (239 / 255), (213 / 255), 1.0]),
    peachpuff: new Color("rgb", [(255 / 255), (218 / 255), (185 / 255), 1.0]),
    peru: new Color("rgb", [(205 / 255), (133 / 255), (63 / 255), 1.0]),
    pink: new Color("rgb", [(255 / 255), (192 / 255), (203 / 255), 1.0]),
    plum: new Color("rgb", [(221 / 255), (160 / 255), (221 / 255), 1.0]),
    powderblue: new Color("rgb", [(176 / 255), (224 / 255), (230 / 255), 1.0]),
    rosybrown: new Color("rgb", [(188 / 255), (143 / 255), (143 / 255), 1.0]),
    royalblue: new Color("rgb", [(65 / 255), (105 / 255), (225 / 255), 1.0]),
    saddlebrown: new Color("rgb", [(139 / 255), (69 / 255), (19 / 255), 1.0]),
    salmon: new Color("rgb", [(250 / 255), (128 / 255), (114 / 255), 1.0]),
    sandybrown: new Color("rgb", [(244 / 255), (164 / 255), (96 / 255), 1.0]),
    seagreen: new Color("rgb", [(46 / 255), (139 / 255), (87 / 255), 1.0]),
    seashell: new Color("rgb", [(255 / 255), (245 / 255), (238 / 255), 1.0]),
    sienna: new Color("rgb", [(160 / 255), (82 / 255), (45 / 255), 1.0]),
    skyblue: new Color("rgb", [(135 / 255), (206 / 255), (235 / 255), 1.0]),
    slateblue: new Color("rgb", [(106 / 255), (90 / 255), (205 / 255), 1.0]),
    slategray: new Color("rgb", [(112 / 255), (128 / 255), (144 / 255), 1.0]),
    slategrey: new Color("rgb", [(112 / 255), (128 / 255), (144 / 255), 1.0]),
    snow: new Color("rgb", [(255 / 255), (250 / 255), (250 / 255), 1.0]),
    springgreen: new Color("rgb", [(0 / 255), (255 / 255), (127 / 255), 1.0]),
    steelblue: new Color("rgb", [(70 / 255), (130 / 255), (180 / 255), 1.0]),
    tan: new Color("rgb", [(210 / 255), (180 / 255), (140 / 255), 1.0]),
    thistle: new Color("rgb", [(216 / 255), (191 / 255), (216 / 255), 1.0]),
    tomato: new Color("rgb", [(255 / 255), (99 / 255), (71 / 255), 1.0]),
    turquoise: new Color("rgb", [(64 / 255), (224 / 255), (208 / 255), 1.0]),
    violet: new Color("rgb", [(238 / 255), (130 / 255), (238 / 255), 1.0]),
    wheat: new Color("rgb", [(245 / 255), (222 / 255), (179 / 255), 1.0]),
    whitesmoke: new Color("rgb", [(245 / 255), (245 / 255), (245 / 255), 1.0]),
    yellowgreen: new Color("rgb", [(154 / 255), (205 / 255), (50 / 255), 1.0]),
    rebeccapurple: new Color("rgb", [(102 / 255), (51 / 255), (153 / 255), 1.0])
};

let hexRegex = new RegExp("^#\\s*(?:(([a-fA-F0-9]{6}|[a-fA-F0-9]{3})|))\\s*", "i");
let rgbRegex = new RegExp("^rgb\\(\\s*([0-9]{1,3})\\s*,\\s*([0-9]{1,3})\\s*,\\s*([0-9]{1,3})\\s*\\)", "i");
let rgbaRegex = new RegExp("^rgba\\(\\s*([0-9]{1,3})\\s*,\\s*([0-9]{1,3})\\s*,\\s*([0-9]{1,3})\\s*,\\s*([0-9]*\.?[0-9]+)\\s*\\)", "i");
let hslRegex = new RegExp("^hsl\\(\\s*([0-9]{1,3})\\s*,\\s*([0-9]*\.?[0-9]+)%\\s*,\\s*([0-9]*\.?[0-9]+)%\\s*\\)", "i");
let hslaRegex = new RegExp("^hsla\\(\\s*([0-9]{1,3})\\s*,\\s*([0-9]*\.?[0-9]+)%\\s*,\\s*([0-9]*\.?[0-9]+)%\\s*,\\s*([0-9]*\.?[0-9]+)\\s*\\)", "i");
let displayP3Regex = new RegExp("^color\\(\\s*display-p3\\s+([0-9]*\.?[0-9]+)\\s+([0-9]*\.?[0-9]+)\\s+([0-9]*\.?[0-9]+)\\s*(?:/\\s*([0-9]*\.?[0-9]+)\\s*)?\\)", "i");

class CSSColorAssistantClass {
    constructor() {
        this.supportedFormat = ['named', 'rgb', 'hsl', 'hex'];
        this.namedColors = CSSNamedColors;
    }
    
    parseColorStrings(strings) {
        let objs = [];
        for (let string of strings) {
            objs.push(this.parseString(string));
        }
        return objs;
    }
    
    parseString(string) {
        // Parses a CSS color string into an color object
        let match = null;
        if ((match = string.match(hexRegex))) {
            let matchStr = match[1];
            if (matchStr.length == 6) {
                let red = parseInt(matchStr.substring(0, 2), 16);
                let green = parseInt(matchStr.substring(2, 4), 16);
                let blue = parseInt(matchStr.substring(4, 6), 16);
                
                red = red / 255.0;
                green = green / 255.0;
                blue = blue / 255.0;
                
                return new Color("hex", [red, green, blue, 1.0]);
            }
            else if (matchStr.length == 3) {
                let redStr = matchStr.substring(0, 1);
                let greenStr = matchStr.substring(1, 2);
                let blueStr = matchStr.substring(2, 3);
                
                let red = parseInt(redStr + redStr, 16);
                let green = parseInt(greenStr + greenStr, 16);
                let blue = parseInt(blueStr + blueStr, 16);
                
                red = red / 255.0;
                green = green / 255.0;
                blue = blue / 255.0;
                
                return new Color("hex", [red, green, blue, 1.0]);
            }
        }
        else if ((match = string.match(rgbaRegex))) {
            let red = parseInt(match[1]);
            let green = parseInt(match[2]);
            let blue = parseInt(match[3]);
            let alpha = parseFloat(match[4]);
            
            red = red / 255.0;
            green = green / 255.0;
            blue = blue / 255.0;
            
            return new Color("rgb", [red, green, blue, alpha]);
        }
        else if ((match = string.match(rgbRegex))) {
            let red = parseInt(match[1]);
            let green = parseInt(match[2]);
            let blue = parseInt(match[3]);
            
            red = red / 255.0;
            green = green / 255.0;
            blue = blue / 255.0;
            
            return new Color("rgb", [red, green, blue, 1.0]);
        }
        else if ((match = string.match(hslaRegex))) {
            let hue = parseInt(match[1]);
            let sat = parseFloat(match[2]);
            let lum = parseFloat(match[3]);
            let alpha = parseFloat(match[4]);
            
            hue = hue / 360.0;
            sat = sat / 100.0;
            lum = lum / 100.0;
            
            return new Color("hsl", [hue, sat, lum, alpha]);
        }
        else if ((match = string.match(hslRegex))) {
            let hue = parseInt(match[1]);
            let sat = parseFloat(match[2]);
            let lum = parseFloat(match[3]);
            
            hue = hue / 360.0;
            sat = sat / 100.0;
            lum = lum / 100.0;
            
            return new Color("hsl", [hue, sat, lum, 1.0]);
        }
        else if ((match = string.match(displayP3Regex))) {
            let red = parseFloat(match[1]);
            let green = parseFloat(match[2]);
            let blue = parseFloat(match[3]);
            let alpha = (match[4] ? parseFloat(match[4]) : 1.0);
            
            return new Color("p3", [red, green, blue, alpha]);
        }
        else {
            // Named
            let namedColor = CSSNamedColors[string];
            if (namedColor) {
                return namedColor;
            }
        }
        return null;
    }
    
    outputColorStrings(colors) {
        let strings = [];
        for (let obj of colors) {
            strings.push(this.outputColor(obj));
        }
        return strings;
    }
    
    outputColor(color) {
        // Converts a color object into a CSS color string
        let format = color.format;
        let components = color.components;
        
        if (format == "rgb") {
            let red = components[0];
            let green = components[1];
            let blue = components[2];
            let alpha = components[3];
            
            red = red * 255.0;
            green = green * 255.0;
            blue = blue * 255.0;
            
            if (alpha == 1.0) {
                return 'rgb(' + red.toFixed() + ', ' + green.toFixed() + ', ' + blue.toFixed() + ')';
            }
            else {
                return 'rgba(' + red.toFixed() + ', ' + green.toFixed() + ', ' + blue.toFixed() + ', ' + alpha.toFixed(2) + ')';
            }
        }
        else if (format == "hsl") {
            let hue = components[0];
            let sat = components[1];
            let lum = components[2];
            let alpha = components[3];
            
            hue = hue * 360.0;
            sat = sat * 100.0;
            lum = lum * 100.0;
            
            if (alpha == 1.0) {
                return 'hsl(' + hue.toFixed() + ', ' + sat.toFixed() + '%, ' + lum.toFixed() + '%)';
            }
            else {
                return 'hsla(' + hue.toFixed() + ', ' + sat.toFixed() + '%, ' + lum.toFixed() + '%, ' + alpha.toFixed(2) + ')';
            }
        }
        else if (format == "hex") {
            let redHex = Math.floor(components[0]).toString(16);
            if (redHex.length == 1) {
                redHex = '0' + redHex;
            }
            let greenHex = Math.floor(components[1]).toString(16);
            if (greenHex.length == 1) {
                greenHex = '0' + greenHex;
            }
            let blueHex = Math.floor(components[2]).toString(16);
            if (blueHex.length == 1) {
                blueHex = '0' + blueHex;
            }
            return '#' + redHex + greenHex + blueHex;
        }
        else if (format == "p3") {
            let red = components[0];
            let green = components[1];
            let blue = components[2];
            let alpha = components[3];
            
            if (alpha == 1.0) {
                return 'color(display-p3 ' + red.toFixed() + ' ' + green.toFixed() + ' ' + blue.toFixed() + ')';
            }
            else {
                return 'color(display-p3 ' + red.toFixed() + ' ' + green.toFixed() + ' ' + blue.toFixed() + ' / ' + alpha.toFixed(2) + ')';
            }
        }
        else {
            return '';
        }
    }
}

module.exports = new CSSColorAssistantClass();
